Subject: Re: [core] MULTIPART-CT: A few editorial comments

From: Christer Holmberg <[email-masked]>
Date: Wed, 21 Aug 2019 20:39:48 +0000

Hi,

Unless I have missed it, I would appreciate if the issues below could be addressed. They should only be editorial.

Regards,

Christer

Lähettäjä: core <[email-masked]> Puolesta Christer Holmberg
Lähetetty: tiistai 23. heinäkuuta 2019 17.53
Vastaanottaja: [email-masked]
Aihe: [core] MULTIPART-CT: A few editorial comments

Hi,

A few minor editorial comments on draft-ietf-core-multipart-ct-03:

(I haven’t read the IESG review comments, so my apologies if someone has already raised these comments)

---

Q1:

The Introduction says talks about “request or response body’.

However, when looking in RFC 7252, I don’t find ‘body’ anywhere.

I assume that ‘body’ refers to what RFC 7252 calls ‘payload’. If so, I suggest aligning the terminology.

(For some reason section 10.2.3 of RFC 7252 does use ‘message-body’, without any explanation or reference, but I guess that is just an error)

---

Q2:

Related to Q1, the text says:

   “can be used to combine representations of zero or more different media types into a single message”

I assume it means ‘single message payload’? Because, you are not combing other parts (Codes, Tokens etc) of the message, are you?

I think it would be more clear if you said ‘combine multiple representations, each using the same or different media types, into a single message payload’.

---

Q3: The draft uses both ‘media type’ and ‘media-type’. RFC 7252 uses ‘media type’ (there is one instance of ‘media-type’, though), so maybe align with that?

Regards,

Christer

---

From: Carsten Bormann <[email-masked]>
Date: Thu, 22 Aug 2019 11:56:48 +0200

Hi Christer,

thank you for alerting us to this oversight.
(And thank you for the critical reading in the first place!)

> However, when looking in RFC 7252, I don’t find ‘body’ anywhere.

Right.  Body is an RFC 7959 term (which was adapted from HTTP’s “Message Body”, obviously).

I didn’t really want to muddy the picture by explaining again that CoAP block-wise transfers can cut up a single body into multiple payloads (as per RFC 7959).  The current text already might be misunderstood to say that this media type is CoAP specific, which it is not at all.

We didn’t go to the trouble of having a formal terminology import section (apart from the usual BCP14 boilerplate in 1.1).  We could add that text, reference 7959 and 7230 as well, and make this abundantly clear.  Or we could leave it as it is.

> (For some reason section 10.2.3 of RFC 7252 does use ‘message-body’, without any explanation or reference, but I guess that is just an error)

That is about the message-body on the HTTP side, so it is exactly as it should be.

(Actually, 1.2 of 7252 says 
 »This specification requires readers to be familiar with all the terms
  and concepts that are discussed in [RFC2616], including "resource",
  "representation", "cache", and "fresh".  (Having been completed
  before the updated set of HTTP RFCs, RFC 7230 to RFC 7235, became
  available, this specification specifically references the predecessor
  version -- RFC 2616.)  In addition, this specification defines the
  following terminology: « […]

So this term is already defined in RFC 7252, albeit implicitly only.)

>   “can be used to combine representations of zero or more different media types into a single message”

Actually, it now says

  This memo defines application/multipart-core, an application-
  independent media-type that can be used to combine representations of
  zero or more different media types, each along with a CoAP Content-
  Format identifier, into a single representation, with minimal framing
  overhead.  This combined representation may then be carried in a
  single message, such as a CoAP [RFC7252] request or response body.

(Where “message” might be a whole block-wise transfer.)

Is that better?

> I assume it means ‘single message payload’? Because, you are not combing other parts (Codes, Tokens etc) of the message, are you?

To carry that in a single message, you would carry it in the message’s payload (or, theoretically, in an option, but we only do that in OSCORE so far).

> I think it would be more clear if you said ‘combine multiple representations, each using the same or different media types, into a single message payload’.

The new text above more clearly separates the representation combining from the ability to send it in a single message then.

> 
> ---
> 
> Q3: The draft uses both ‘media type’ and ‘media-type’.

Yeah, that’s a bit funny.
I actually believe we should have used media-type throughout the history of the term, as this is an artificial construct that only loosely relates to media types (types of media).
But maybe this draft is not the place to correct this mistake which has been in place since 1996.

> RFC 7252 uses ‘media type’ (there is one instance of ‘media-type’, though),

That one instance is in the construction “media-type ranges”, which is the normal way to compose composites in English.

> so maybe align with that?

I’m sure the RFC editor will force us to do that anyway, but I have made the change to “media type” (with a space) in the editors’ copy in case we get to submit another version.  Waiting for CI to show this at
https://core-wg.github.io/multipart-ct/draft-ietf-core-multipart-ct.html

(And the RFC editor will make us expand abbreviations and all that, too.)

Grüße, Carsten

---

From: Christer Holmberg <[email-masked]>
Date: Fri, 23 Aug 2019 10:04:15 +0000

Hi,

>   Right.  Body is an RFC 7959 term (which was adapted from HTTP’s “Message Body”, obviously).

When we define a CoAP extension, we should adapt the terminology used in 7252. 

"CoAP request or response body" is not MULTIPART-CT specific terminology - it is something that should be defined in 7252.

Also, I have no problem separating between "body" and "body payload" (or just "payload"), but the difference needs to be described.

> I didn’t really want to muddy the picture by explaining again that CoAP block-wise transfers can cut up a 
> single body into multiple payloads (as per RFC 7959).  The current text already might be misunderstood to
> say that this media type is CoAP specific, which it is not at all.
>  
> We didn’t go to the trouble of having a formal terminology import section (apart from the usual BCP14 boilerplate in 1.1).  
> We could add that text, reference 7959 and 7230 as well, and make this abundantly clear.  Or we could leave it as it is.
   
When you refer to different parts/content of a CoAP message, there needs to be a definition of what it is.

>    So this term is already defined in RFC 7252, albeit implicitly only.)  

HTTP does not define "CoAP request or response body".

And, even if it does, why is "body" not used in 7252? 

---

  > (Where “message” might be a whole block-wise transfer.)
    
  The text looks better, eventhough it still uses "request or response body" (see Q1).

  However, my understanding of "message" is a CoAP request or response. If it means something else, you need to define it.

---

Regards,

Christer